/*
 * Copyright (C) 2013 Philippe Komma
 * 
 * This file is part of k-Means: A C++ clustering library 
 * 
 * k-Means is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with k-Means. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __INIT_MODEL_H__
#define __INIT_MODEL_H__

#include "ClusterModel.h"

template <class T> class IInitModel
{
	protected:

		IClusterModel<T>* m_clusterModel;

	public:

		IInitModel() :
		    m_clusterModel( NULL )
		{
		}

		IInitModel( IClusterModel<T>* clusterModel ) : 
			m_clusterModel( clusterModel )
		{			
		}

		IClusterModel<T>* clusterModel() {
			return m_clusterModel;
		}

		virtual bool init() = 0;
};

#endif