/*
 * Copyright (C) 2013 Philippe Komma
 * 
 * This file is part of k-Means: A C++ clustering library 
 * 
 * k-Means is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with k-Means. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __STRING_UTILS_H__
#define __STRING_UTILS_H__

#include <string>
#include <vector>
#include <sstream>

typedef struct {
	std::string drive;
	std::string path;
	std::string name;
	std::string ext;
} FileInfo;

template <class T> T str_conversion( const std::string& str )
{
    T result;
    std::stringstream ss( str );
    ss >> result;
    return result;
}

std::string str_replace( const std::string& str, const std::string& from, const std::string& to );

std::string str_ltrim( const std::string& str, const std::string& delims = " \t\r\n" );

std::string str_rtrim( const std::string& str, const std::string& delims = " \t\r\n" );

std::string str_trim( const std::string& str, const std::string& delims = " \t\r\n" );

std::vector<std::string> str_split( const std::string& str, const std::string& delims = " \t\r\n" );

void str_fsplit( const std::string& fname, FileInfo& info );

void str_fsplit( const std::string& str, std::string* drive, std::string* path, std::string* fname, std::string* extension );

#endif
