/*
 * Copyright (C) 2013 Philippe Komma
 * 
 * This file is part of k-Means: A C++ clustering library 
 * 
 * k-Means is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with k-Means. If not, see <http://www.gnu.org/licenses/>.
 */

#include <windows.h>

class Timer
{
	private:

		LARGE_INTEGER m_lpPerformanceCount;

		LONGLONG m_freq;

		LONGLONG m_start;

	public:

		Timer( bool run = true ) {
			QueryPerformanceFrequency( &m_lpPerformanceCount );
			m_freq = m_lpPerformanceCount.QuadPart;
			if ( run ) {
				start();
			}
		}

		void start() {
			QueryPerformanceCounter( &m_lpPerformanceCount );
			m_start = m_lpPerformanceCount.QuadPart;
		}

		unsigned int passed() {
			QueryPerformanceCounter( &m_lpPerformanceCount );
			return ( unsigned int )( ( m_lpPerformanceCount.QuadPart - m_start ) * 1000 / m_freq );
		}
};