/*
 * Copyright (C) 2013 Philippe Komma
 * 
 * This file is part of k-Means: A C++ clustering library 
 * 
 * k-Means is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with k-Means. If not, see <http://www.gnu.org/licenses/>.
 */

#pragma warning( disable : 4702 )

#include <iostream>
	using std::cout;
	using std::endl;
#include <string>
	using std::string;

#include "Timer.h"
#include "Vector.h"
#include "DataSet.h"
#include "sseUtils.h"
#include "StringUtils.h"

#include "KMeansModel.h"
#include "InitModelKKZ.h"

#include "Matrix.h"

#include "MemUtils.h"
#include "MathUtils.h"
#include "SortUtils.h"

int main()
{
	CDataSet<float> dataSet;
	if ( !dataSet.rawImport( "c:/Media/datasets/accY_vel2_fft_subset.ascii" ) ) {
		cout << "could not open dataSet" << endl;
	} 

	cout << dataSet.nInst() << "x" << dataSet.nFeat() << endl;

	CKMeansModel<float> kmeans( &dataSet, 5 );

	CInitModelKKZ<float>* initModel = new CInitModelKKZ<float>( &kmeans );

	initModel->init();

	kmeans.cluster( 10 );

	return 0;
}