/*
 * Copyright (C) 2013 Philippe Komma
 * 
 * This file is part of k-Means: A C++ clustering library 
 * 
 * k-Means is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with k-Means. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SSE_UTILS_H__
#define __SSE_UTILS_H__

#include <iostream>

typedef __declspec( align( 16 ) ) float AlignedMemory16f;

class CSSEUtils
{
	public:

		struct CPUInfo {
			bool fpuAvail;
			bool mmxAvail;
			bool sseAvail;
			bool sse2Avail;
			bool sse3Avail;
			bool sse41Avail;
			bool sse42Avail;
			bool aesAvail;
			bool avxAvail;
			bool htAvail;
		};

		static void info( CPUInfo& info );

		friend std::ostream& operator<<( std::ostream& output, const CPUInfo& info );
};

#endif